package it.eng.spago.services;

import it.eng.spago.dispatching.service.RequestContextIFace;


/**
 * Interface for the service catalog manager.
 */
public interface ServiceCatalogIFace {
     /**
     *  Return an instance of the service registered with <code>name</code>
     *
     *@param reqCtx. Context used to retrive and store services.
     *@param  name. Name of the registered service.
     *@return The service instance.
     *@exception Exception.
     */
//    public ServiceInterface getService(String name) throws ServiceException;
    public ServiceInterface getService(RequestContextIFace reqCtx, String name) throws Exception;


    /**
     *  Say if a service with the given name is registered.
     *
     *@param  name  Description of the Parameter
     *@return       The serviceAvailable value
     */
    public boolean isServiceAvailable(String name);

    /**
     *  Gets the serviceList attribute of the ServiceCatalogIFace object
     *
     *@return    The serviceList value
     */
//    public Enumeration getServiceList();

}
