/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.audit.action;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.console.endpoint.action.StepDetailAction;
import it.eng.console.util.DateFormatter;
import it.eng.spago.base.SourceBean;
import it.eng.spago.message.MessageBundle;

import java.text.DateFormat;
import java.util.List;

import org.spagic.metadb.model.TransitionInstance;

public class TransitionInstancesAction extends StepDetailAction {

	private static final long serialVersionUID = 1L;

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String stepName = (String)serviceRequest.getAttribute("stepId");
		long processInstanceId = Long.parseLong((String)serviceRequest.getAttribute("processInstanceId"));
		
		SourceBean journalInstancesBean = createDetailBean(stepName);
		SourceBean stepPropertiesBean = createPropertiesBean(stepName);
		journalInstancesBean.setAttribute(stepPropertiesBean);
		
		SourceBean journalInstancesListBean = new SourceBean("JOURNAL_INSTANCES_LIST");
		List<TransitionInstance> transitionInstancesList = ProcessInstanceBO.getTransitionInstance((Long)journalInstancesBean.getAttribute("id"), processInstanceId);
//		List<StepInstance> stepInstancesList = ProcessInstanceBO.getStepInstances((Long)journalInstancesBean.getAttribute("id"), processInstanceId);
		SourceBean transitionInstanceBean = null;
		String stateId = null;
		int stepInstanceCounter = 0;
//		StepInstance stepInstance = null;
		for(TransitionInstance transitionInstance : transitionInstancesList) {
//			if (stepInstancesList.size() > 0)
//				stepInstance = (StepInstance)stepInstancesList.get(stepInstanceCounter++);
			transitionInstanceBean = new SourceBean("ITEM");
			transitionInstanceBean.setAttribute("id", transitionInstance.getIdJournal());
			stateId = Integer.toString(transitionInstance.getTransitionState().getIdState());
			transitionInstanceBean.setAttribute("stato", MessageBundle.getMessage(stateId, "properties.console.console"));
			
			DateFormat formatter = DateFormatter.getShortTimeFormat(getRequestContainer().getSessionContainer());
			String dateTemp = formatter.format(transitionInstance.getTransitionStart());					
			transitionInstanceBean.setAttribute("inizio", dateTemp);	
			transitionInstanceBean.setAttribute("attachment", transitionInstance.getAttachmentIn() + transitionInstance.getAttachmentOut());
			
			boolean isTransitionDataNotNull = ProcessInstanceBO.isTransitionDataNotNull(transitionInstance.getIdJournal());
			transitionInstanceBean.setAttribute("link", isTransitionDataNotNull ? "1" : "0");
			
//			if (stepInstance != null) {
//				transitionInstanceBean.setAttribute("idStepInstance", stepInstance.getIdStepInstance());
//				transitionInstanceBean.setAttribute("stepInstanceState", stepInstance.getStepInstanceState().getStateValue());
//			}
			journalInstancesListBean.setAttribute(transitionInstanceBean);
		}
		journalInstancesBean.setAttribute(journalInstancesListBean);
		serviceResponse.setAttribute(journalInstancesBean);
	}

}
