package it.eng.console.process.action;

import org.spagic.metadb.model.Process;

import it.eng.console.process.bo.ProcessBO;
import it.eng.jmx.bo.JmxBO;
import it.eng.jmx.util.JMXUtil;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.action.AbstractAction;
import it.eng.spago.message.MessageBundle;

public class ChangeStatusAction extends AbstractAction {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
			throws Exception {
		String processIdFromRequest = (String)serviceRequest.getAttribute("processId");
		String oldStatus = (String)serviceRequest.getAttribute("oldStatus");
		long processId = Long.parseLong(processIdFromRequest);
		Process process  = ProcessBO.getProcessDetail(processId);
		String serviceAssemblyName = JMXUtil.createServiceAssemblyName(process.getName(), process.getProcessVersion());
		try {
			String newState = JmxBO.changeStatus(serviceAssemblyName, oldStatus);
			serviceResponse.setAttribute("newState", newState);
		}catch(Exception ex) {
			String errorMsg = MessageBundle.getMessage("10012", "properties.console.messages");
			serviceResponse.setAttribute("error", errorMsg);
		}
	}

}
