/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.console.tag;

import it.eng.console.audit.bo.ProcessInstanceBO;
import it.eng.console.process.bo.ProcessBO;
import it.eng.console.util.Constants;
import it.eng.console.util.HTMLContentGenerator;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.ResponseContainerAccess;
import it.eng.spago.base.SourceBean;
import it.eng.spago.message.MessageBundle;
import it.eng.spago.tracing.TracerSingleton;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

import org.spagic.metadb.model.PoolType;

public class ParentPocessLinkTag extends TagSupport {	
	protected String _idProcessInstance = null;
	protected SourceBean _serviceResponse = null;
	protected StringBuffer _outputHtml = null;
	protected HttpServletRequest httpRequest = null;
	
    public int doStartTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "ParentPocessLinkTag::doStartTag:: invocato");
        if(pageContext == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL,
                "ParentPocessLinkTag::doStartTag:: pageContext nullo");
            throw new JspException("pageContext nullo");
        } 
        try {
            httpRequest = (HttpServletRequest) pageContext.getRequest();
        } catch(Exception ex) {
            TracerSingleton.log(
            		Constants.project, TracerSingleton.CRITICAL, "ParentPocessLinkTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        } 
        if(httpRequest == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ParentPocessLinkTag::doStartTag:: httpRequest nullo");
            throw new JspException("httpRequest nullo");
        } 
        ResponseContainer responseContainer =
            ResponseContainerAccess.getResponseContainer(httpRequest);
        if(responseContainer == null) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "ParentPocessLinkTag::doStartTag:: httpRequest nullo");
            throw new JspException("responseContainer nullo");
        }        
        
    	_serviceResponse = responseContainer.getServiceResponse();
    	
    	generateLink();
        try {
            pageContext.getOut().print(_outputHtml.toString());
        } catch(Exception ex) {
            TracerSingleton.log(Constants.project, TracerSingleton.CRITICAL, "IterTypeComboTag::doStartTag::", ex);
            throw new JspException(ex.getMessage());
        }
        return SKIP_BODY;
    } 
    
    private void generateLink() {
    	_outputHtml = new StringBuffer();
    	//ProcessInstanceBO.
    	_outputHtml.append("<a href=\"#\" onclick=\"showProcess()\"><img src=\"\"/></a>");
    	
    }

	public String get_idProcessInstance() {
		return _idProcessInstance;
	}

	public void set_idProcessInstance(String processInstance) {
		_idProcessInstance = processInstance;
	}

	/**
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag() throws JspException {
        TracerSingleton.log(Constants.project, TracerSingleton.DEBUG, "IterTypeComboTag::doEndTag:: invocato");
        return super.doEndTag();
    }
}
